



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MVC 使用HandleErrorAttribute统一处理异常</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MVC 使用HandleErrorAttribute统一处理异常</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 22:52:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>HandleErrorAttribute继承自<strong>FilterAttribute</strong>，且实现了<strong>IExceptionFilter</strong>接口。</p>
<p>属于AOP思想的一种实现，MVC的四大筛选器（权限，动作，结果，异常）中的异常处理。</p>
<p>Points:</p>
<p>1）ExceptionHandled为true，表明异常已经处理，不再被拦截；反之，可能被再次拦截；</p>
<p>2）通过设置ExceptionContext的Result（ActionResult类型）属性，表明<strong>结束当前请求</strong>。</p>
<h1>Usage</h1>
<h2>1.创建自定义异常处理</h2>
<div>
<pre class="prettyprint linenums">public class AppHandleErrorAttribute : HandleErrorAttribute<br />
{<br />
    public override void OnException(ExceptionContext filterContext)<br />
    {<br />
        var json = new JsonResponse();<br />
        json.success = false;<br />
        var ex = filterContext.Exception;<br />
        //deal custom exception&hellip;<br />
        json.message = "系统异常，请联系管理员!";<br />
        string msg = string.Format("系统异常:{0}", ex.Message);<br />
        LogHelper.Error(msg, ex);   //Log4jNet

        filterContext.ExceptionHandled = true;<br />
        var result = new JsonResult();<br />
        result.Data = json;<br />
        result.JsonRequestBehavior = JsonRequestBehavior.AllowGet;<br />
        filterContext.Result = result;

        #region Sample Segment（样例）<br />
        if (filterContext.HttpContext.Request.IsAjaxRequest())<br />
        {<br />
            JsonResult jsonResult = new JsonResult()<br />
            {<br />
                Data = ""<br />
            };

            LogHelper.Error(filterContext.Exception.Message);

            filterContext.Result = jsonResult;<br />
        }<br />
        else<br />
        {<br />
            filterContext.Result = new RedirectResult("Error");<br />
        }

        filterContext.ExceptionHandled = true;<br />
        #endregion<br />
    }<br />
}</pre>
</div>
<h2>2.注册</h2>
<div>
<pre class="prettyprint linenums">public class FilterConfig<br />
{<br />
    public static void RegisterGlobalFilters(GlobalFilterCollection filters)<br />
    {<br />
        filters.Add(new<strong> AppHandleErrorAttribute</strong>());<br />
    }<br />
}</pre>
</div>
<p>参考：<a href="http://www.cnblogs.com/linjiancun/archive/2010/09/16/1827937.html" rel="external nofollow noreferrer">http://www.cnblogs.com/linjiancun/archive/2010/09/16/1827937.html</a></p>
<h2>3.使用</h2>
<p>如果要运用AppHandleError拦截异常，则将Controller继承自BaseController即可。</p>
<div>
<pre class="prettyprint linenums">[<strong>AppHandleError</strong>]<br />
public abstract class<strong> BaseController</strong> : Controller<br />
{<br />
    //......<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw0v0z9.html">Mysql 5&period;7&period;12 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mpke08.html">web storage和cookie的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/495d370q.html">JSTL函数标签库 fn标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7m309.html">自动解析URL</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g26578.html">更改PATH后，别忘了及时重启或刷新</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd6ojx8.html">iMx280A测试声纹</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnlzoq.html">python接口的调用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmjj079.html">删除Android自带软件方法及adb remount 失败解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvk73zq.html">Spring EL hello world example</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn16z238.html">POJ 1014 Dividing  多重背包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ev4x8.html">【转】Android 驱动开发系列四</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngl6oq.html">SQL性能优化的思路建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0kjw8.html">JavaScript两个变量交换值（不使用临时变量）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17wmjq.html">csv文件转json</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyk7vm9.html">&commat;property的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1vw2q.html">look back to 2018</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv144lyq.html">CFUpdate高速模式下出现Error &num;2038提示的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zodk2xq.html">qt 标签 QTextBrowser QLabel</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5e61q.html">docker国内镜像源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj46ge9.html">oracle 存储过程（包）的写法和执行</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8ed4mj9.html">Connect the Cities&lpar;MST prim&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4xjr38.html">输入的全角字符转换成半角字符--css、js、ASP&period;NET</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zmydd9.html">FineUI第四天---PageManage的概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/49563ve8.html">Unity3D研究院之自制批量关联材质与贴图插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jkm7e8.html">sql大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/390odrm9.html">&lbrack;UOJ&num;131&rsqb;&lbrack;BZOJ4199&rsqb;&lbrack;NOI2015&rsqb;品酒大会  后缀数组 &plus; 并查集</a>
			</li>
						<li><a href="https://www.batexi.com/a/390ojnn9.html">django-cms 代码研究（六）plugin的深入分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdmk6jq.html">Linux下安装firefox最新版</a>
			</li>
						<li><a href="https://www.batexi.com/a/4956znz8.html">Enum&colon;Hopscotch&lpar;POJ 3050&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jkvke8.html">Java删除文件夹和文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
